/*   Random Nuclear Holocaust Generator.  By Taper Wickel.   */
    
/*     Placed in Public Domain 1 October 1997.  Share and enjoy. */

    
/*     Based loosely on the postscript to The Tale of Happiton in Douglas */
/*     Hofstadter's _Metamagical_Themas_.  See the README for more */
/*     details.                                                */

#include <stdio.h>
#include <sys/time.h>
#include <unistd.h>

#define WALD 20  /* the Wald Number. */

main ( )
{
    int num, i, chance, diff;
    struct timeval foo;
    struct timezone bar;

/* Seed the random number generator
   with the time + the milliseconds. */
    gettimeofday ( &foo, &bar);
    srand ( (int) (foo.tv_sec + foo.tv_usec));

/* initialize the variables; set num high enough so the 
   loop happens.  */
    num = 99;
    chance = WALD;
    i = 0;

    while ( (num > chance) && (i < 500))
    {    
	num =  (rand( ) % 1000);
	i++;
	diff = ( rand () % 20) - 10;
	chance += diff ; 
/*Don't want there to be a negative chance, now do we? */
	if ( chance < 0)
	{
	    chance = 0 ;
	}
    }
    if (i < 500)
    {
	printf ( "It took %d years to destroy the world.\n", i);
    }
    else
    {
	printf ( "You win!  500 years without destruction!\n");
    }
}
